﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Forms;

namespace Xenon.KifuNarabe
{


    /// <summary>
    /// プレイ関連
    /// </summary>
    public abstract class Actions_Play
    {

        /// <summary>
        /// 駒を動かします(1)。
        /// </summary>
        public static void Komamove1ByMouseDown(Button_Koma selectedBtnKoma, Button_Masu btnMasu, Taikyoku taikyoku)
        {
            //------------------------------
            // 駒の移動
            //------------------------------
            System.Console.WriteLine("★selectedBtnKoma.KomaProperty.Sengo=" + Converter.SengoToStr(selectedBtnKoma.KomaProperty.Sengo));
            System.Console.WriteLine("★btnMasu.Masu.Okiba=" + btnMasu.Masu.Okiba);
            System.Console.WriteLine("★btnMasu.Masu.Suji=" + btnMasu.Masu.Suji);
            System.Console.WriteLine("★btnMasu.Masu.Dan=" + btnMasu.Masu.Dan);
            System.Console.WriteLine("★taikyoku.MouseProcessOrNull.SrcSyurui=" + Converter.SyuruiToFugo(taikyoku.MouseProcessOrNull.SrcSyurui));

            KomaSyurui tottaKoma;
            Process dst = new Process(
                    selectedBtnKoma.KomaProperty.Sengo,
                    btnMasu.Masu.Okiba,
                    btnMasu.Masu.Suji,
                    btnMasu.Masu.Dan,
                    taikyoku.MouseProcessOrNull.SrcSyurui
                );

            System.Console.WriteLine("取れる駒はあるか？");
            //----------
            // 将棋盤上のその場所に駒はあるか
            //----------
            tottaKoma = KomaSyurui.TOTTA_KOMA_NASI;
            Button_Koma underKoma = taikyoku.Kifu.Kyokumen.Btn_AtMasuDokodemo(Okiba.SHOGIBAN, dst);//盤上
            if (null != underKoma)
            {
                // 駒があったとき
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                tottaKoma = underKoma.KomaProperty.Syurui;

                // その駒は、駒置き場に移動させます。
                Process ukProcess;
                switch (dst.Sengo)//sengo
                {
                    case Sengo.GOTE:

                        ukProcess = Actions_Koma.GetKomadaiSpace(Okiba.GOTE_KOMADAI, taikyoku);
                        if (null != ukProcess)
                        {
                            // 駒台に空きスペースがありました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            // 取られる動き
                            underKoma.KomaProperty = new Process(
                                Sengo.GOTE,
                                Okiba.GOTE_KOMADAI,//駒台へ
                                ukProcess.Suji,
                                ukProcess.Dan,
                                Converter.SyuruiToFunariCase(underKoma.KomaProperty.Syurui) // 取った駒は非成へ
                                );
                        }
                        else
                        {
                            // エラー：　駒台に空きスペースがありませんでした。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            // 取られる動き
                            underKoma.KomaProperty = new Process(
                                Sengo.GOTE,
                                Okiba.GOTE_KOMADAI,
                                Process.ERROR_SUJI,
                                Process.ERROR_DAN,
                                Converter.SyuruiToFunariCase(underKoma.KomaProperty.Syurui) // 取った駒は非成へ
                                );
                        }

                        Actions_Koma.RefreshKomaLocation(underKoma, taikyoku);
                        break;

                    case Sengo.SENTE://thru
                    default:

                        ukProcess = Actions_Koma.GetKomadaiSpace(Okiba.SENTE_KOMADAI, taikyoku);
                        if (null != ukProcess)
                        {
                            // 駒台に空きスペースがありました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            // 取られる動き
                            underKoma.KomaProperty = new Process(
                                Sengo.SENTE,
                                Okiba.SENTE_KOMADAI,//駒台へ
                                ukProcess.Suji,
                                ukProcess.Dan,
                                Converter.SyuruiToFunariCase(underKoma.KomaProperty.Syurui) // 取った駒は非成へ
                                );
                        }
                        else
                        {
                            // エラー：　駒台に空きスペースがありませんでした。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            // 取られる動き
                            underKoma.KomaProperty = new Process(
                                Sengo.SENTE,
                                Okiba.SENTE_KOMADAI,
                                Process.ERROR_SUJI,
                                Process.ERROR_DAN,
                                Converter.SyuruiToFunariCase(underKoma.KomaProperty.Syurui) // 取った駒は非成へ
                                );
                        }

                        Actions_Koma.RefreshKomaLocation(underKoma, taikyoku);
                        break;
                }

                //------------------------------
                // 成りは解除。
                //------------------------------
                switch (underKoma.KomaProperty.Okiba)
                {
                    case Okiba.SENTE_KOMADAI://thru
                    case Okiba.GOTE_KOMADAI:
                        // 駒台へ移動しました
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        KomaSyurui syurui2 = underKoma.KomaProperty.ToFunariCase();

                        underKoma.KomaProperty = new Process(
                            underKoma.KomaProperty.Sengo,
                            underKoma.KomaProperty.Okiba,
                            underKoma.KomaProperty.Suji,
                            underKoma.KomaProperty.Dan,
                            syurui2
                            );

                        break;
                }

                // 取った駒を一次記憶します。
                taikyoku.SetMouseProcessOrNull(
                    new Process(
                        taikyoku.MouseProcessOrNull.Sengo,
                        taikyoku.MouseProcessOrNull.Okiba,
                        taikyoku.MouseProcessOrNull.SrcOkiba,
                        taikyoku.MouseProcessOrNull.Suji,
                        taikyoku.MouseProcessOrNull.Dan,
                        taikyoku.MouseProcessOrNull.SrcSuji,
                        taikyoku.MouseProcessOrNull.SrcDan,
                        taikyoku.MouseProcessOrNull.Syurui,
                        taikyoku.MouseProcessOrNull.SrcSyurui,
                        tottaKoma
                        )
                    );
            }

            System.Console.WriteLine("*駒移動");
            //------------------------------
            // 駒移動
            //------------------------------
            //
            //      選択している駒を、その場所に移動させます。
            //
            selectedBtnKoma.KomaProperty = dst;


            System.Console.WriteLine("再描画？");
            Actions_Koma.RefreshKomaLocation(selectedBtnKoma, taikyoku);
        }

        /// <summary>
        /// 駒を動かします(2)。
        /// </summary>
        public static void Komamove2ByMouseUp(
            Button_Koma k,
            Taikyoku taikyoku,
            Uc_Main uc_Main
            )
        {
            //----------
            // 移動済表示
            //----------
            k.Moved = true;

            //------------------------------
            // 棋譜に符号を追加
            //------------------------------
            System.Console.WriteLine("棋譜追加？");
            // 棋譜
            Process process = new Process(
                taikyoku.Sengo,
                k.KomaProperty.Okiba,
                taikyoku.MouseProcessOrNull.SrcOkiba,
                k.KomaProperty.Suji,
                k.KomaProperty.Dan,
                taikyoku.MouseProcessOrNull.SrcSuji,
                taikyoku.MouseProcessOrNull.SrcDan,
                k.KomaProperty.Syurui,
                taikyoku.MouseProcessOrNull.SrcSyurui,
                taikyoku.MouseProcessOrNull.TottaKoma
                );// 選択している駒の元の場所と、移動先

            taikyoku.Kifu.Add(process);


            //------------------------------
            // 符号表示
            //------------------------------
            View_Fugo fugo;
            fugo = Translator_MasuToFugo1.TranslateProcessToFugo(process, taikyoku.Kifu.Kyokumen);
            Process previousProcess = taikyoku.Kifu.Last; //符号の追加が行われる前に退避
            uc_Main.LblFugo.Text = fugo.ToText(true, process, previousProcess);



            System.Console.WriteLine("棋譜出力？");
            //------------------------------
            // 棋譜出力
            //------------------------------
            uc_Main.OutputKifu();

            System.Console.WriteLine("チェンジターン？");
            //------------------------------
            // チェンジターン
            //------------------------------
            Process last = taikyoku.Kifu.Last;
            taikyoku.ChangeTurn(last.Suji, last.Dan, uc_Main);
        }

        /// <summary>
        /// TODO: 一手進む、一手戻るに対応。
        /// 
        /// 棋譜再生時用（マウス操作のときは関係ない）
        /// </summary>
        /// <param name="process">srcには現在升、dstには移動先升</param>
        /// <param name="taikyoku"></param>
        /// <param name="back"></param>
        public static void KifusasiAndKomamove(Process process, Taikyoku taikyoku, bool back)
        {
            Button_Koma btnMovedKoma;
            Button_Koma btn_tottaKoma = null;

            //------------------------------------------------------------
            // 選択  ：  動かす駒
            //------------------------------------------------------------
            {
                System.Console.WriteLine("打か？将棋盤か？");

                if (back)
                {
                    // [戻る]とき
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    // 打った駒も、指した駒も、結局は将棋盤の上にあるはず。

                    // 将棋盤
                    btnMovedKoma = taikyoku.Kifu.Kyokumen.Btn_AtMasu(
                        process.Sengo,
                        new Process(
                            process.Sengo,
                            process.Okiba,
                            process.Suji,//戻るときは、先位置が　駒の居場所。
                            process.Dan,//戻るときは、先位置が　駒の居場所。
                            process.Syurui
                            )
                            );
                }
                else
                {
                    // 進むとき
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    if (process.IsDaAction)
                    {
                        //----------
                        // 駒台から “打”
                        //----------

                        btnMovedKoma = taikyoku.Kifu.Kyokumen.Btn_BySyuruiIgnoreCase(
                            process.SrcOkiba,
                            process.Syurui
                            );
                    }
                    else
                    {
                        //----------
                        // 将棋盤から
                        //----------

                        btnMovedKoma = taikyoku.Kifu.Kyokumen.Btn_AtMasu(
                            process.Sengo,
                            new Process(
                                process.Sengo,
                                process.Okiba,
                                process.SrcSuji,
                                process.SrcDan,
                                process.Syurui
                                )
                                );
                    }
                }

                if (null == btnMovedKoma)
                {
                    goto gt_Paint;
                }
            }

            //------------------------------------------------------------
            // 確定  ：  移動先升
            //------------------------------------------------------------
            KomaSyurui syurui2;
            {
                //----------
                // 成るかどうか
                //----------
                System.Console.WriteLine("成るのか？");

                if (process.IsNatta_Process)
                {
                    if (back)
                    {
                        // 成ったのなら、非成に戻します。
                        syurui2 = Converter.SyuruiToFunariCase(process.Syurui);
                    }
                    else
                    {
                        syurui2 = process.Syurui;
                    }
                }
                else
                {
                    syurui2 = process.Syurui;
                }
                System.Console.WriteLine("○syurui2=" + Converter.SyuruiToFugo(syurui2));
            }

            Process dst;
            if (back)
            {
                int suji;
                int dan;

                if (Okiba.GOTE_KOMADAI == process.SrcOkiba
                    || Okiba.SENTE_KOMADAI == process.SrcOkiba)
                {
                    // 駒台の空いている場所
                    Process akiMasu = Actions_Koma.GetKomadaiSpace(process.SrcOkiba, taikyoku);
                    // 必ず空いている場所があるものとします。

                    suji = akiMasu.Suji;
                    dan = akiMasu.Dan;
                }
                else
                {
                    // 将棋盤上の元の位置
                    suji = process.SrcSuji;//戻し先
                    dan = process.SrcDan;//戻し先
                }


                dst = new Process(
                        process.Sengo,
                        process.SrcOkiba,//戻し先
                        suji,
                        dan,
                        syurui2
                        );
            }
            else
            {
                dst = new Process(
                        process.Sengo,
                        process.Okiba,
                        process.Suji,
                        process.Dan,
                        syurui2
                        );
            }

            System.Console.WriteLine("○process.Sengo=" + Converter.SengoToStr(process.Sengo));
            System.Console.WriteLine("○process.Okiba=" + process.Okiba);
            System.Console.WriteLine("○process.Suji=" + process.Suji);
            System.Console.WriteLine("○process.Dan=" + process.Dan);

            //------------------------------------------------------------
            // 駒を取る
            //------------------------------------------------------------
            if(!back)
            {
                KomaSyurui tottaKoma;

                System.Console.WriteLine("取れる駒があるか？");
                //----------
                // 将棋盤上のその場所に駒はあるか
                //----------
                tottaKoma = KomaSyurui.TOTTA_KOMA_NASI;
                Button_Koma underKoma = taikyoku.Kifu.Kyokumen.Btn_AtMasuDokodemo(Okiba.SHOGIBAN, dst);//盤上
                if (null != underKoma)
                {
                    // 駒があったとき
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                    tottaKoma = underKoma.KomaProperty.Syurui;

                    // その駒は、駒置き場に移動させます。
                    Process ukProcess;
                    switch (dst.Sengo)//sengo
                    {
                        case Sengo.GOTE:

                            ukProcess = Actions_Koma.GetKomadaiSpace(Okiba.GOTE_KOMADAI, taikyoku);
                            if (null != ukProcess)
                            {
                                // 駒台に空きスペースがありました。
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                // 取られる動き
                                underKoma.KomaProperty = new Process(
                                    Sengo.GOTE,
                                    Okiba.GOTE_KOMADAI,//駒台へ
                                    ukProcess.Suji,
                                    ukProcess.Dan,
                                    Converter.SyuruiToFunariCase(underKoma.KomaProperty.Syurui) // 取った駒は非成へ
                                    );
                            }
                            else
                            {
                                // エラー：　駒台に空きスペースがありませんでした。
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                // 取られる動き
                                underKoma.KomaProperty = new Process(
                                    Sengo.GOTE,
                                    Okiba.GOTE_KOMADAI,
                                    Process.ERROR_SUJI,
                                    Process.ERROR_DAN,
                                    Converter.SyuruiToFunariCase(underKoma.KomaProperty.Syurui) // 取った駒は非成へ
                                    );
                            }

                            Actions_Koma.RefreshKomaLocation(underKoma, taikyoku);
                            break;

                        case Sengo.SENTE://thru
                        default:

                            ukProcess = Actions_Koma.GetKomadaiSpace(Okiba.SENTE_KOMADAI, taikyoku);
                            if (null != ukProcess)
                            {
                                // 駒台に空きスペースがありました。
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                // 取られる動き
                                underKoma.KomaProperty = new Process(
                                    Sengo.SENTE,
                                    Okiba.SENTE_KOMADAI,//駒台へ
                                    ukProcess.Suji,
                                    ukProcess.Dan,
                                    Converter.SyuruiToFunariCase(underKoma.KomaProperty.Syurui) // 取った駒は非成へ
                                    );
                            }
                            else
                            {
                                // エラー：　駒台に空きスペースがありませんでした。
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                // 取られる動き
                                underKoma.KomaProperty = new Process(
                                    Sengo.SENTE,
                                    Okiba.SENTE_KOMADAI,
                                    Process.ERROR_SUJI,
                                    Process.ERROR_DAN,
                                    Converter.SyuruiToFunariCase(underKoma.KomaProperty.Syurui) // 取った駒は非成へ
                                    );
                            }

                            Actions_Koma.RefreshKomaLocation(underKoma, taikyoku);
                            break;
                    }

                    //------------------------------
                    // 成りは解除。
                    //------------------------------
                    switch (underKoma.KomaProperty.Okiba)
                    {
                        case Okiba.SENTE_KOMADAI://thru
                        case Okiba.GOTE_KOMADAI:
                            // 駒台へ移動しました
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            underKoma.KomaProperty = new Process(
                                underKoma.KomaProperty.Sengo,
                                underKoma.KomaProperty.Okiba,
                                underKoma.KomaProperty.Suji,
                                underKoma.KomaProperty.Dan,
                                underKoma.KomaProperty.ToFunariCase()
                                );

                            break;
                    }



                    //------------------------------
                    // 取った駒を棋譜に覚えさせます。（差替え）
                    //------------------------------
                    Process last;
                    taikyoku.Kifu.PopLast(out last);

                    if (null != last)
                    {
                        taikyoku.Kifu.Add(
                            new Process(
                                last.Sengo,
                                last.Okiba,
                                last.SrcOkiba,
                                last.Suji,
                                last.Dan,
                                last.SrcSuji,
                                last.SrcDan,
                                last.Syurui,
                                last.SrcSyurui,
                                tottaKoma
                                )
                            );
                    }
                }

            }

            //------------------------------------------------------------
            // 駒の移動
            //------------------------------------------------------------
            System.Console.WriteLine("駒移動？");
            btnMovedKoma.KomaProperty = dst;


            //------------------------------------------------------------
            // 取った駒を戻す
            //------------------------------------------------------------
            if (back)
            {
                System.Console.WriteLine("取った駒を戻す？");
                if (
                    KomaSyurui.TOTTA_KOMA_NASI != process.TottaKoma
                    && KomaSyurui.UNKNOWN != process.TottaKoma
                    )
                {
                    System.Console.WriteLine("★★取った駒=" + Converter.SyuruiToFugo(process.TottaKoma));
                    System.Console.WriteLine("★★取った方の先後=" + Converter.SengoToKanji(process.Sengo));

                    // 駒台から、駒を検索します。
                    Okiba okiba;
                    if (Sengo.GOTE == process.Sengo)
                    {
                        okiba = Okiba.GOTE_KOMADAI;
                    }
                    else
                    {
                        okiba = Okiba.SENTE_KOMADAI;
                    }

                    btn_tottaKoma = taikyoku.Kifu.Kyokumen.Btn_BySyuruiIgnoreCase(okiba, process.TottaKoma);
                    if (null != btn_tottaKoma)
                    {
                        btn_tottaKoma.KomaProperty = new Process(
                            Converter.AlternateSengo(process.Sengo),
                            Okiba.SHOGIBAN,
                            process.Suji,
                            process.Dan,
                            process.TottaKoma
                            );
                    }
                        
                }
            }


        gt_Paint:

            //------------------------------------------------------------
            // 駒・再描画
            //------------------------------------------------------------
            System.Console.WriteLine("駒再描画");
            //foreach (Button_Koma koma in taikyoku.Kifu.Kyokumen.Items)
            //{
            //    Actions_Koma.RefreshKomaLocation(koma, taikyoku);
            //}

            if (null != btnMovedKoma)
            {
                Actions_Koma.RefreshKomaLocation(btnMovedKoma, taikyoku);
            }

            if (null != btn_tottaKoma)
            {
                Actions_Koma.RefreshKomaLocation(btn_tottaKoma, taikyoku);
            }
        }


        /// <summary>
        /// [再生]ボタン
        /// </summary>
        public static void Saisei(Uc_Main uc_Main)
        {
            // コマ送りに成功している間、コマ送りし続けます。
            while (Actions_Play.ItteSusumu_ByKifu(uc_Main))
            {
            }
        }

        /// <summary>
        /// [コマ送り]ボタン
        /// </summary>
        public static bool Komaokuri(Uc_Main uc_Main)
        {
            return Actions_Play.ItteSusumu_ByKifu(uc_Main);
        }

        /// <summary>
        /// [戻る]ボタン
        /// </summary>
        public static bool Modoru(Uc_Main uc_Main)
        {
            bool successful = false;

            //------------------------------
            // 棋譜から１手削ります
            //------------------------------
            Process last;
            uc_Main.Taikyoku.Kifu.PopLast(out last);

            if (null == last)
            {
                goto gt_EndMethod;
            }


            //------------------------------
            // 入力欄
            //------------------------------
            View_Fugo lastFugo;
            lastFugo = Translator_MasuToFugo1.TranslateProcessToFugo(last, uc_Main.Taikyoku.Kifu.Kyokumen);
            string lastFutoStr = lastFugo.ToText(true, last, uc_Main.Taikyoku.Kifu.Last);
            uc_Main.SetInputText(lastFutoStr + " " + uc_Main.GetInputText().Trim());


            //------------------------------
            // 前の手に戻します
            //------------------------------
            Actions_Play.KifusasiAndKomamove(last, uc_Main.Taikyoku, true);



            //------------------------------
            // 符号表示
            //------------------------------
            uc_Main.LblFugo.Text = lastFutoStr;


            //------------------------------
            // 棋譜出力
            //------------------------------
            uc_Main.OutputKifu();

            //------------------------------
            // チェンジターン
            //------------------------------
            uc_Main.Taikyoku.ChangeTurn(last.Suji, last.Dan, uc_Main);
            uc_Main.Refresh();

            successful = true;


        gt_EndMethod:
            return successful;
        }

        /// <summary>
        /// １手進む
        /// 
        /// ＜棋譜読込用＞＜マウス入力非対応＞
        /// </summary>
        public static bool ItteSusumu_ByKifu(Uc_Main uc_Main)
        {
            bool successful = false;

            Process process;
            string restText;

            uc_Main.SetInputText(uc_Main.GetInputText().Trim());

            if (uc_Main.GetInputText().StartsWith("position"))
            {
                // SFEN形式の局面です。
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                uc_Main.SetInputText(uc_Main.GetInputText().Substring("position".Length));
                uc_Main.SetInputText(uc_Main.GetInputText().Trim());
                successful = true;

                bool nextMoves = false;

                if (uc_Main.GetInputText().StartsWith("startpos"))
                {
                    // 平手の初期配置です。
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    uc_Main.SetInputText(uc_Main.GetInputText().Substring("startpos".Length));
                    uc_Main.SetInputText(uc_Main.GetInputText().Trim());

                    Actions_Kifu.Syokihaichi(uc_Main.Taikyoku);
                    uc_Main.ClearTxtOutput();
                    uc_Main.Refresh();

                    nextMoves = true;
                }
                else
                {
                    //　「lnsgkgsnl/1r5b1/ppppppppp/9/9/6P2/PPPPPP1PP/1B5R1/LNSGKGSNL w - 1」といった文字の読込み
                    if (!Translator_SfenStartpos.TranslateSfenStartpos(uc_Main.GetInputText(), out restText, uc_Main.Taikyoku))
                    {
                    }
                    else
                    {
                        uc_Main.SetInputText(restText);

                        uc_Main.ClearTxtOutput();
                        uc_Main.Refresh();

                        nextMoves = true;
                    }
                }

                if (nextMoves)
                {
                    if (uc_Main.GetInputText().StartsWith("moves"))
                    {
                        // 棋譜が始まります。
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        uc_Main.SetInputText(uc_Main.GetInputText().Substring("moves".Length));
                        uc_Main.SetInputText(uc_Main.GetInputText().Trim());
                    }
                }

            }

            //「▲６六歩」形式と想定して読込み
            if (!Translator_FugotextToProcess.TranslateFugotextToProcess(uc_Main.GetInputText(), out restText, out process, uc_Main.Taikyoku.Kifu, uc_Main.Taikyoku))
            {
                //「6g6f」形式と想定して読込み
                if (!Translator_SfenToProcess.TranslateSfenToProcess(uc_Main.GetInputText(), out restText, out process, uc_Main.Taikyoku.Kifu, uc_Main.Taikyoku.Kifu.Kyokumen, uc_Main.Taikyoku))
                {

                }
            }
            uc_Main.SetInputText(restText);


            if (null != process)
            {
                Application.DoEvents(); // 時間のかかる処理の間にはこれを挟みます。

                //------------------------------------------------------------
                // 1手ずつ
                //------------------------------------------------------------
                View_Fugo fugo;
                Process previousProcess = uc_Main.Taikyoku.Kifu.Last; //符号の追加が行われる前に退避

                //------------------------------
                // 符号の追加
                //------------------------------
                System.Console.WriteLine("棋譜追加？");
                uc_Main.Taikyoku.Kifu.Add(process);
                fugo = Translator_MasuToFugo1.TranslateProcessToFugo(process, uc_Main.Taikyoku.Kifu.Kyokumen);

                //------------------------------
                // ★棋譜読込専用  駒移動
                //------------------------------
                Actions_Play.KifusasiAndKomamove(process, uc_Main.Taikyoku, false);

                //------------------------------
                // 符号表示
                //------------------------------
                uc_Main.LblFugo.Text = fugo.ToText(true, process, previousProcess);


                //------------------------------
                // 棋譜出力
                //------------------------------
                uc_Main.OutputKifu();

                //------------------------------
                // チェンジターン
                //------------------------------
                Process last = uc_Main.Taikyoku.Kifu.Last;
                uc_Main.Taikyoku.ChangeTurn(last.Suji, last.Dan, uc_Main);
                uc_Main.Refresh();

                successful = true;
            }

            return successful;
        }


        /// <summary>
        /// 棋譜最後の駒の成／不成を切り替えます。
        /// </summary>
        public static void Nari_KifuLast(Button_Koma btnKoma, Taikyoku taikyoku)
        {
            Process last;
            taikyoku.Kifu.PopLast(out last);


            if (null != last)
            {
                // 最後の符号の成／不成も変えます。

                if (btnKoma.KomaProperty.Nari)
                {
                    //------------------------------
                    // 成→不成
                    //------------------------------

                    //----------
                    // 棋譜
                    //----------
                    Process process = new Process(
                        last.Sengo,
                        last.Okiba,
                        last.SrcOkiba,
                        last.Suji,
                        last.Dan,
                        last.SrcSuji,
                        last.SrcDan,
                        btnKoma.KomaProperty.ToFunariCase(),//不成
                        last.SrcSyurui,
                        last.TottaKoma
                        );
                    taikyoku.Kifu.Add(process);

                    //----------
                    // 駒
                    //----------
                    btnKoma.KomaProperty = new Process(
                        btnKoma.KomaProperty.Sengo,
                        btnKoma.KomaProperty.Okiba,
                        btnKoma.KomaProperty.Suji,
                        btnKoma.KomaProperty.Dan,
                        btnKoma.KomaProperty.ToFunariCase()//不成
                        );

                }
                else
                {
                    //------------------------------
                    // 不成→成
                    //------------------------------

                    //----------
                    // 棋譜
                    //----------
                    Process process = new Process(
                        last.Sengo,
                        last.Okiba,
                        last.SrcOkiba,
                        last.Suji,
                        last.Dan,
                        last.SrcSuji,
                        last.SrcDan,
                        btnKoma.KomaProperty.ToNariCase(),//成り
                        last.SrcSyurui,
                        last.TottaKoma
                        );
                    taikyoku.Kifu.Add(process);

                    //----------
                    // 駒
                    //----------
                    btnKoma.KomaProperty = new Process(
                        btnKoma.KomaProperty.Sengo,
                        btnKoma.KomaProperty.Okiba,
                        btnKoma.KomaProperty.Suji,
                        btnKoma.KomaProperty.Dan,
                        btnKoma.KomaProperty.ToNariCase()//成り
                        );

                }
            }


            //----------
            // 駒の選択解除
            //----------
            btnKoma.Deselect();


            Actions_Koma.RefreshKomaLocation(btnKoma, taikyoku);
        }
    }


}
