﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Reflection;
using System.Text.RegularExpressions;

namespace Xenon.KifuNarabe
{

    /// <summary>
    /// 「lnsgkgsn1/1r5b1/ppppppppp/9/9/9/PPPPPPPPP/1B5R1/LNSGKGSNL w - 1」といった記述を解析します。
    /// </summary>
    public abstract class Translator_SfenStartpos
    {

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public static bool TranslateSfenStartpos(string text, out string restText, Taikyoku taikyoku)
        {
            System.Console.WriteLine("TranslateSfenStartpos: text=" + text);

            bool successful = false;

            restText = text;

            //------------------------------------------------------------
            // リスト作成
            //------------------------------------------------------------
            Regex regex = new Regex(
                @"^\s*"+
                @"([123456789KRBGSNLPkrbgsnlp\+]+)/" +//1段目
                @"([123456789KRBGSNLPkrbgsnlp\+]+)/" +//2段目
                @"([123456789KRBGSNLPkrbgsnlp\+]+)/" +//3段目
                @"([123456789KRBGSNLPkrbgsnlp\+]+)/" +//4段目
                @"([123456789KRBGSNLPkrbgsnlp\+]+)/" +//5段目
                @"([123456789KRBGSNLPkrbgsnlp\+]+)/" +//6段目
                @"([123456789KRBGSNLPkrbgsnlp\+]+)/" +//7段目
                @"([123456789KRBGSNLPkrbgsnlp\+]+)/" +//8段目
                @"([123456789KRBGSNLPkrbgsnlp\+]+) " +//9段目
                @"(b|w) "+//先後
                @"\-?"+
                @"(?:K(\d+))?" +//▲王
                @"(?:R(\d+))?" +//▲飛
                @"(?:B(\d+))?" +//▲角
                @"(?:G(\d+))?" +//▲金
                @"(?:S(\d+))?" +//▲銀
                @"(?:N(\d+))?" +//▲桂
                @"(?:L(\d+))?" +//▲香
                @"(?:P(\d+))?" +//▲歩
                @"(?:k(\d+))?" +//△王
                @"(?:r(\d+))?" +//△飛
                @"(?:b(\d+))?" +//△角
                @"(?:g(\d+))?" +//△金
                @"(?:s(\d+))?" +//△銀
                @"(?:n(\d+))?" +//△桂
                @"(?:l(\d+))?" +//△香
                @"(?:p(\d+))?" +//△歩
                @" (\d+)" +//手目
                @"",
                RegexOptions.Singleline
            );

            MatchCollection mc = regex.Matches(text);
            foreach (Match m in mc)
            {
                if (0 < m.Groups.Count)
                {
                    successful = true;

                    // 残りのテキスト
                    restText = text.Substring(0, m.Index) + text.Substring(m.Index + m.Length, text.Length - (m.Index + m.Length));

                    Translator_SfenStartpos.TranslateArgs(
                        m.Groups[1].Value,  //1段目
                        m.Groups[2].Value,  //2段目
                        m.Groups[3].Value,  //3段目
                        m.Groups[4].Value,  //4段目
                        m.Groups[5].Value,  //5段目
                        m.Groups[6].Value,  //6段目
                        m.Groups[7].Value,  //7段目
                        m.Groups[8].Value,  //8段目
                        m.Groups[9].Value,  //9段目
                        m.Groups[10].Value,  //先後
                        m.Groups[11].Value,  //▲王
                        m.Groups[12].Value,  //▲飛
                        m.Groups[13].Value,  //▲角
                        m.Groups[14].Value,  //▲金
                        m.Groups[15].Value,  //▲銀
                        m.Groups[16].Value,  //▲桂
                        m.Groups[17].Value,  //▲香
                        m.Groups[18].Value,  //▲歩
                        m.Groups[19].Value,  //△王
                        m.Groups[20].Value,  //△飛
                        m.Groups[21].Value,  //△角
                        m.Groups[22].Value,  //△金
                        m.Groups[23].Value,  //△銀
                        m.Groups[24].Value,  //△桂
                        m.Groups[25].Value,  //△香
                        m.Groups[26].Value,  //△歩
                        m.Groups[27].Value,  //手目
                        taikyoku
                        );
                }

                // 最初の１件だけ処理して終わります。
                break;
            }

            restText = restText.Trim();

            return successful;
        }


        /// <summary>
        /// 符号１「7g7f」を元に、process を作ります。
        /// 
        /// ＜再生、コマ送りで呼び出されます＞
        /// </summary>
        /// <returns></returns>
        private static void TranslateArgs(
            string dan1,  //1段目
            string dan2,//2段目
            string dan3,//3段目
            string dan4,//4段目
            string dan5,//5段目
            string dan6,  //6段目
            string dan7,  //7段目
            string dan8,  //8段目
            string dan9,  //9段目
            string strSengo,  //先後
            string mK,  //▲王
            string mR,  //▲飛
            string mB,  //▲角
            string mG,  //▲金
            string mS,  //▲銀
            string mN,  //▲桂
            string mL,  //▲香
            string mP,  //▲歩
            string mk,  //△王
            string mr,  //△飛
            string mb,  //△角
            string mg,  //△金
            string ms,  //△銀
            string mn,  //△桂
            string ml,  //△香
            string mp,  //△歩
            string teme,  //手目
            Taikyoku taikyoku
            )
        {
            //------------------------------
            // 駒を駒袋に移動
            //------------------------------
            taikyoku.ClearToKomabukuro();


            string[] strDanArr = new string[]{
                "",
                dan1,
                dan2,
                dan3,
                dan4,
                dan5,
                dan6,
                dan7,
                dan8,
                dan9
            };


            int spaceCount;
            Sengo sengo;
            KomaSyurui syurui;
            //------------------------------
            // 1段目～9段目
            //------------------------------
            for (int dan = 1; dan <= 9; dan++)
            {
                //System.Console.WriteLine("strDanArr[" + dan + "]=" + strDanArr[dan]);
                int suji = 9;

                while (suji >= 1)
                {
                    if (strDanArr[dan].Length < 1)
                    {
                        break;
                    }

                    string moji;
                    moji = strDanArr[dan].Substring(0, 1);
                    if (1 <= strDanArr[dan].Length)
                    {
                        strDanArr[dan] = strDanArr[dan].Substring(1, strDanArr[dan].Length - 1);
                    }
                    else
                    {
                        strDanArr[dan] = "";
                    }

                    if ("+" == moji && 1 <= strDanArr[dan].Length)
                    {
                        // もう１文字、切り取ります。
                        moji = moji + strDanArr[dan].Substring(0, 1);
                        strDanArr[dan] = strDanArr[dan].Substring(1, strDanArr[dan].Length - 1);
                    }

                    System.Console.WriteLine("　　　　moji=" + moji);

                    if (int.TryParse(moji, out spaceCount))
                    {
                        // スペースの個数です。
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        System.Console.WriteLine("　　　　spaceCount=" + spaceCount);
                        suji -= spaceCount;
                    }
                    else
                    {
                        // 駒でした。
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        Converter.SfenSyokihaichiToSyurui(moji, out sengo, out syurui);

                        //System.Console.WriteLine("　　　　sengo=" + sengo.ToString());
                        //System.Console.WriteLine("　　　　syurui=" + syurui.ToString());

                        List<Button_Koma> komas = taikyoku.Kifu.Kyokumen.Btns_ByOkibaSengoSyurui(
                            Okiba.KOMABUKURO,
                            sengo,
                            Converter.SyuruiToFunariCase(syurui)
                            );
                        System.Console.WriteLine("　　　　komas.Count=" + komas.Count);

                        // それぞれの駒に適用
                        foreach (Button_Koma koma in komas)
                        {


                            koma.KomaProperty = new Process(
                                sengo,
                                Okiba.SHOGIBAN,
                                suji,
                                dan,
                                syurui
                                );

                            Actions_Koma.RefreshKomaLocation(koma, taikyoku);

                            //System.Console.WriteLine("　　　　suji=" + suji + "　dan=" + dan);
                            //System.Console.WriteLine("　　　　koma.Masu.Sengo=" + koma.Masu.Sengo);
                            //System.Console.WriteLine("　　　　koma.Masu.Okiba=" + koma.Masu.Okiba);
                            //System.Console.WriteLine("　　　　koma.Masu.Suji=" + koma.Masu.Suji);
                            //System.Console.WriteLine("　　　　koma.Masu.Dan=" + koma.Masu.Dan);
                            //System.Console.WriteLine("　　　　koma.Masu.Syurui=" + koma.Masu.Syurui);

                            break;
                        }

                        suji--;
                    }
                }
            }

            //------------------------------
            // 先後
            //------------------------------
            System.Console.WriteLine("strSengo=" + strSengo);
            if ("w" == strSengo)
            {
                taikyoku.SetSengo(Sengo.GOTE);
            }
            else
            {
                taikyoku.SetSengo(Sengo.SENTE);
            }

            //------------------------------
            // ▲王
            //------------------------------
            {
                int count;
                if (int.TryParse(mK, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.SENTE, Okiba.SENTE_KOMADAI, KomaSyurui.OH, count, taikyoku);
                }
            }
            System.Console.WriteLine("mK=" + mK);

            //------------------------------
            // ▲飛
            //------------------------------
            {
                int count;
                if (int.TryParse(mR, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.SENTE, Okiba.SENTE_KOMADAI, KomaSyurui.HISYA, count, taikyoku);
                }
            }
            System.Console.WriteLine("mR=" + mR);

            //------------------------------
            // ▲角
            //------------------------------
            {
                int count;
                if (int.TryParse(mB, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.SENTE, Okiba.SENTE_KOMADAI, KomaSyurui.KAKU, count, taikyoku);
                }
            }
            System.Console.WriteLine("mB=" + mB);

            //------------------------------
            // ▲金
            //------------------------------
            {
                int count;
                if (int.TryParse(mG, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.SENTE, Okiba.SENTE_KOMADAI, KomaSyurui.KIN, count, taikyoku);
                }
            }
            System.Console.WriteLine("mG=" + mG);

            //------------------------------
            // ▲銀
            //------------------------------
            {
                int count;
                if (int.TryParse(mS, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.SENTE, Okiba.SENTE_KOMADAI, KomaSyurui.GIN, count, taikyoku);
                }
            }
            System.Console.WriteLine("mS=" + mS);

            //------------------------------
            // ▲桂
            //------------------------------
            {
                int count;
                if (int.TryParse(mN, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.SENTE, Okiba.SENTE_KOMADAI, KomaSyurui.KEI, count, taikyoku);
                }
            }
            System.Console.WriteLine("mN=" + mN);

            //------------------------------
            // ▲香
            //------------------------------
            {
                int count;
                if (int.TryParse(mL, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.SENTE, Okiba.SENTE_KOMADAI, KomaSyurui.KYO, count, taikyoku);
                }
            }
            System.Console.WriteLine("mL=" + mL);

            //------------------------------
            // ▲歩
            //------------------------------
            {
                int count;
                if (int.TryParse(mP, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.SENTE, Okiba.SENTE_KOMADAI, KomaSyurui.FU, count, taikyoku);
                }
            }
            System.Console.WriteLine("mP=" + mP);

            //------------------------------
            // △王
            //------------------------------
            {
                int count;
                if (int.TryParse(mk, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.GOTE, Okiba.GOTE_KOMADAI, KomaSyurui.OH, count, taikyoku);
                }
            }
            System.Console.WriteLine("mk=" + mk);

            //------------------------------
            // △飛
            //------------------------------
            {
                int count;
                if (int.TryParse(mr, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.GOTE, Okiba.GOTE_KOMADAI, KomaSyurui.HISYA, count, taikyoku);
                }
            }
            System.Console.WriteLine("mr=" + mr);

            //------------------------------
            // △角
            //------------------------------
            {
                int count;
                if (int.TryParse(mb, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.GOTE, Okiba.GOTE_KOMADAI, KomaSyurui.KAKU, count, taikyoku);
                }
            }
            System.Console.WriteLine("mb=" + mb);

            //------------------------------
            // △金
            //------------------------------
            {
                int count;
                if (int.TryParse(mg, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.GOTE, Okiba.GOTE_KOMADAI, KomaSyurui.KIN, count, taikyoku);
                }
            }
            System.Console.WriteLine("mg=" + mg);

            //------------------------------
            // △銀
            //------------------------------
            {
                int count;
                if (int.TryParse(ms, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.GOTE, Okiba.GOTE_KOMADAI, KomaSyurui.GIN, count, taikyoku);
                }
            }
            System.Console.WriteLine("ms=" + ms);

            //------------------------------
            // △桂
            //------------------------------
            {
                int count;
                if (int.TryParse(mn, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.GOTE, Okiba.GOTE_KOMADAI, KomaSyurui.KEI, count, taikyoku);
                }
            }
            System.Console.WriteLine("mn=" + mn);

            //------------------------------
            // △香
            //------------------------------
            {
                int count;
                if (int.TryParse(ml, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.GOTE, Okiba.GOTE_KOMADAI, KomaSyurui.KYO, count, taikyoku);
                }
            }
            System.Console.WriteLine("ml=" + ml);

            //------------------------------
            // △歩
            //------------------------------
            {
                int count;
                if (int.TryParse(mp, out count))
                {
                    Translator_SfenStartpos.Mochigoma(Sengo.GOTE, Okiba.GOTE_KOMADAI, KomaSyurui.FU, count, taikyoku);
                }
            }
            System.Console.WriteLine("mp=" + mp);

            //------------------------------
            // 手目
            //------------------------------
            System.Console.WriteLine("teme=" + teme);


        }

        private static void Mochigoma(Sengo mSengo, Okiba mOkiba, KomaSyurui mSyurui, int total, Taikyoku taikyoku)
        {
            List<Button_Koma> komas = taikyoku.Kifu.Kyokumen.Btns_ByOkibaSyurui(Okiba.KOMABUKURO, mSyurui);

            int count = 0;
            foreach (Button_Koma koma in komas)
            {
                Process space = Actions_Koma.GetKomadaiSpace(mOkiba, taikyoku);

                koma.KomaProperty = new Process(
                    mSengo,
                    mOkiba,
                    space.Suji,
                    space.Dan,
                    mSyurui
                    );

                Actions_Koma.RefreshKomaLocation(koma, taikyoku);

                if (total <= count)
                {
                    break;
                }

                count++;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="srcAll">候補マス</param>
        /// <param name="komas"></param>
        /// <returns></returns>
        private static bool Hit(Sengo sengo, KomaSyurui syurui, List<Process> srcAll, Kyokumen kyokumen, out Button_Koma found)
        {
            bool hit = false;
            found = null;

            foreach (Process masu in srcAll)//筋・段。（先後、種類は入っていません）
            {
                foreach (Button_Koma btnKoma in kyokumen.Items)//全駒
                {
                    if (sengo == btnKoma.KomaProperty.Sengo
                        && syurui == btnKoma.KomaProperty.Syurui
                        && masu.MatchMasu(btnKoma.KomaProperty)
                        )
                    {
                        // 候補マスにいた
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                        hit = true;
                        found = btnKoma;
                        break;
                    }
                }
            }

            return hit;
        }

    }


}
