﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Text.RegularExpressions;

namespace Xenon.KifuNarabe
{


    /// <summary>
    /// 「▲７六歩△３四歩▲６六歩」形式の棋譜。
    /// </summary>
    public class Kifu1View
    {


        #region プロパティー類
        //------------------------------------------------------------
        private Kifu kifu;

        public Kifu Kifu
        {
            get
            {
                return this.kifu;
            }
        }
        //------------------------------------------------------------
        #endregion


        /// <summary>
        /// 
        /// </summary>
        /// <param name="kifu">現在の局面までの棋譜。</param>
        public Kifu1View(Kifu kifu)
        {
            this.kifu = kifu.Clone();
        }


        /// <summary>
        /// 符号リスト。「▲２六歩△８四歩▲７六歩」…。
        /// </summary>
        /// <param name="fugoList"></param>
        public string ToText()
        {
            StringBuilder sb = new StringBuilder();

            sb.Append("position ");
            sb.Append(this.Kifu.Startpos);
            sb.Append(" moves ");

            // 採譜用に、新しい対局を用意します。
            Taikyoku saifuTaikyoku = new Taikyoku();
            saifuTaikyoku.Kifu.SetStartpos(this.Kifu.Startpos);

            // 初期配置
            Actions_Kifu.Syokihaichi(saifuTaikyoku);


            foreach (Process process in this.Kifu.ProcessList)
            {
                Process previousMasu = saifuTaikyoku.Kifu.Last; //符号の追加が行われる前に退避

                View_Fugo fugo;

                //------------------------------
                // 符号の追加
                //------------------------------
                saifuTaikyoku.Kifu.Add(process);
                fugo = Translator_MasuToFugo1.TranslateProcessToFugo(process, saifuTaikyoku.Kifu.Kyokumen);

                sb.Append(fugo.ToText(true, process, previousMasu));

                // TODO:デバッグ用
                switch (process.TottaKoma)
                {
                    case KomaSyurui.UNKNOWN:
                    case KomaSyurui.TOTTA_KOMA_NASI:
                        break;
                    default:
                        sb.Append("（");
                        sb.Append(Converter.SyuruiToFugo(process.TottaKoma));
                        sb.Append("取り）");
                        break;
                }
            }

            //System.Console.WriteLine("size(" + fugoList.Count+")"+sb.ToString());

            return sb.ToString();
        }

    }


}
