﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Drawing;

namespace Xenon.KifuNarabe
{


    /// <summary>
    /// 将棋盤の升目（はボタン）
    /// </summary>
    public class Button_Masu
    {

        #region プロパティー

        public Process Masu
        {
            get;
            set;
        }

        public Rectangle Bounds
        {
            get;
            set;
        }

        /// <summary>
        /// 光。
        /// </summary>
        public bool Light
        {
            get;
            set;
        }

        /// <summary>
        /// 動かしたい駒。
        /// </summary>
        public bool Select
        {
            get;
            set;
        }

        /// <summary>
        /// 動かしたい駒。
        /// </summary>
        public bool SelectFirstTouch
        {
            get;
            set;
        }

        #endregion


        public Button_Masu(Okiba okiba, int suji, int dan)
        {
            this.Masu = new Process(
                Sengo.SENTE,//先後はダミー値。使わないこと。
                okiba,
                //okiba,
                suji,
                dan,
                //Process.KOMABUKURO_SUJI,
                //Process.KOMABUKURO_DAN,
                KomaSyurui.UNKNOWN
                //KomaSyurui.UNKNOWN,
                //KomaSyurui.TOTTA_KOMA_NASI
                );
            this.Bounds = new Rectangle(42, 42, 35, 35);
        }

        public Button_Masu(Okiba okiba, int suji, int dan, int x, int y)
            : this(okiba, suji, dan)
        {
            this.Bounds = new Rectangle(x, y, this.Bounds.Width, this.Bounds.Height);
        }

        public void Paint(Graphics g1)
        {
            //----------
            // 背景
            //----------
            if (this.Select)
            {
                g1.FillRectangle(Brushes.Brown, this.Bounds);
            }
            else if (this.Light)
            {
            }

            //----------
            // 枠線
            //----------
            {
                if (this.Light)
                {
                    g1.DrawRectangle(Pens.Yellow, this.Bounds);
                }
            }
        }

        /// <summary>
        /// マウスカーソルに重なっているか否か。
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public bool HitByMouse(int x, int y)
        {
            return this.Bounds.Contains(x, y);
        }

        /// <summary>
        /// マウスが重なった駒は、光フラグを立てます。
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public void LightByMouse(int x, int y)
        {
            if (this.HitByMouse(x,y)) // マウスが重なっているなら
            {
                this.Light = true;
            }
            else // マウスが重なっていないなら
            {
                this.Light = false;
            }
        }

        /// <summary>
        /// 動かしたい駒
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public void SelectByMouse(int x, int y)
        {
            // 既に選択されている駒には無効
            if (this.Select)
            {
                goto gt_EndMethod;
            }


            if (this.HitByMouse(x, y)) // マウスが重なっているなら
            {
                this.Select = true;
                this.SelectFirstTouch = true;
            }
            else
            {
                this.Select = false;
                this.SelectFirstTouch = false;
            }

        gt_EndMethod:
            ;
        }

        /// <summary>
        /// 動かしたい駒の解除
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public bool DeselectByMouse(int x, int y)
        {
            bool changed = false;

            if (this.HitByMouse(x, y)) // マウスが重なっているなら
            {
                if (this.SelectFirstTouch)
                {
                    // クリックのマウスアップ
                    this.SelectFirstTouch = false;
                }
                else
                {
                    // 選択解除のマウスアップ
                    this.Select = false;
                    changed = true;
                }
            }
            else
            {
                // 何もしない
            }

            return changed;
        }
    }


}
