﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Drawing;

namespace Xenon.KifuNarabe
{

    /// <summary>
    /// 駒台
    /// </summary>
    public class Komadai
    {

        #region プロパティー

        public int LastSuji
        {
            get;
            set;
        }

        public int LastDan
        {
            get;
            set;
        }

        public int TableX
        {
            get;
            set;
        }

        public int TableY
        {
            get;
            set;
        }

        public int MasuWidth
        {
            get;
            set;
        }

        public int MasuHeight
        {
            get;
            set;
        }

        /// <summary>
        /// 先後
        /// </summary>
        public Sengo Sengo
        {
            get;
            set;
        }

        #endregion

        /// <summary>
        /// 升目
        /// </summary>
        public List<Button_Masu> MasuList
        {
            get;
            set;
        }



        public Komadai(Okiba okiba, int x, int y, Sengo sengo)
        {
            this.LastSuji = 4;
            this.LastDan = 10;

            this.TableX = x;
            this.TableY = y;
            this.MasuWidth = 40;
            this.MasuHeight = 40;

            this.Sengo = sengo;

            //----------
            // 升目
            //----------
            this.MasuList = new List<Button_Masu>();

            for (int suji = 1; suji <= this.LastSuji; suji++)
            {
                for (int dan = 1; dan <= this.LastDan; dan++)
                {
                    this.MasuList.Add(new Button_Masu(okiba, suji, dan, this.SujiToX(suji), this.DanToY(dan)));
                }
            }
        }


        public int SujiToX(int suji)
        {
            return (this.LastSuji - suji) * this.MasuWidth + this.TableX;
        }

        public int DanToY(int dan)
        {
            return (dan-1) * this.MasuHeight + this.TableY;
        }


        public void Paint(Graphics g)
        {
            //----------
            // 水平線
            //----------
            for (int i = 0; i <= this.LastDan; i++)
            {
                g.DrawLine(Pens.Black,
                                0 * this.MasuWidth + this.TableX,
                                i * this.MasuHeight + this.TableY,
                    this.LastSuji * this.MasuHeight + this.TableX,
                                i * this.MasuHeight + this.TableY
                    );
            }

            //----------
            // 垂直線
            //----------
            for (int i = 0; i <= this.LastSuji; i++)
            {
                g.DrawLine(Pens.Black,
                                i * this.MasuWidth + this.TableX,
                                0 * this.MasuHeight + this.TableY,
                                i * this.MasuHeight + this.TableX,
                    this.LastDan  * this.MasuHeight + this.TableY
                    );
            }

            //----------
            // 升目
            //----------
            foreach (Button_Masu cell in this.MasuList)
            {
                cell.Paint(g);
            }

        }


    }
}
