﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Drawing;

namespace Xenon.KifuNarabe
{

    /// <summary>
    /// 将棋盤
    /// </summary>
    public class Shogiban
    {

        #region プロパティー

        public int TableX
        {
            get;
            set;
        }

        public int TableY
        {
            get;
            set;
        }

        public int MasuWidth
        {
            get;
            set;
        }

        public int MasuHeight
        {
            get;
            set;
        }

        #endregion

        /// <summary>
        /// 升目
        /// </summary>
        public List<Button_Masu> MasuList
        {
            get;
            set;
        }



        public Shogiban(int x, int y)
        {
            this.TableX = x;
            this.TableY = y;
            this.MasuWidth = 40;
            this.MasuHeight = 40;

            //----------
            // 升目
            //----------
            this.MasuList = new List<Button_Masu>();

            for (int suji = 1; suji < 10; suji++)
            {
                for (int dan = 1; dan < 10; dan++)
                {
                    this.MasuList.Add(new Button_Masu(Okiba.SHOGIBAN, suji, dan, this.SujiToX(suji), this.DanToY(dan)));
                }
            }

        }


        public int SujiToX(int suji)
        {
            return (9 - suji) * this.MasuWidth + this.TableX;
        }

        public int DanToY(int dan)
        {
            return (dan-1) * this.MasuHeight + this.TableY;
        }


        public void Paint(Graphics g)
        {

            //----------
            // 筋の数字
            //----------
            for (int i = 0; i < 9; i++)
            {
                g.DrawString(Converter.IntToArabiaSuji(i+1), new Font("ＭＳ ゴシック", 25.0f), Brushes.Black, new Point((8 - i) * this.MasuWidth + this.TableX - 8, -1 * this.MasuHeight + this.TableY));
            }

            //----------
            // 段の数字
            //----------
            for (int i = 0; i < 9; i++)
            {
                g.DrawString(Converter.IntToKanSuji(i+1), new Font("ＭＳ ゴシック", 23.0f), Brushes.Black, new Point(9 * this.MasuWidth + this.TableX, i * this.MasuHeight + this.TableY));
                g.DrawString(Converter.IntToAlphabet(i + 1), new Font("ＭＳ ゴシック", 11.0f), Brushes.Black, new Point(9 * this.MasuWidth + this.TableX, i * this.MasuHeight + this.TableY));
            }


            //----------
            // 水平線
            //----------
            for (int i = 0; i < 10; i++)
            {
                g.DrawLine(Pens.Black,
                    0 * this.MasuWidth + this.TableX,
                    i * this.MasuHeight + this.TableY,
                    9 * this.MasuHeight + this.TableX,
                    i * this.MasuHeight + this.TableY
                    );
            }

            //----------
            // 垂直線
            //----------
            for (int i = 0; i < 10; i++)
            {
                g.DrawLine(Pens.Black,
                    i * this.MasuWidth + this.TableX,
                    0 * this.MasuHeight + this.TableY,
                    i * this.MasuHeight + this.TableX,
                    9 * this.MasuHeight + this.TableY
                    );
            }


            //----------
            // 升目
            //----------
            foreach (Button_Masu cell in this.MasuList)
            {
                cell.Paint(g);
            }

        }


    }
}
