﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Text.RegularExpressions;

namespace Xenon.KifuNarabe
{

    [Serializable]
    public partial class Uc_Main : UserControl
    {

        #region プロパティー類

        //------------------------------------------------------------
        private Taikyoku taikyoku;

        public Taikyoku Taikyoku
        {
            get
            {
                return this.taikyoku;
            }
        }
        //------------------------------------------------------------
        public void SetInputText(String text)
        {
            this.txtInput1.Text = text;
        }
        //------------------------------------------------------------
        public void AppendInputText(String text)
        {
            this.txtInput1.Text += text;
        }
        //------------------------------------------------------------
        /// <summary>
        /// 棋譜を出力します。
        /// </summary>
        /// <param name="text"></param>
        public void OutputKifu()
        {
            this.txtOutput1.Text = new Kifu1View(this.Taikyoku.Kifu).ToText();
            this.txtOutput2.Text = new Kifu2View(this.Taikyoku.Kifu).ToText();
        }
        //------------------------------------------------------------
        private Label2 lblSengo;
        /// <summary>
        /// 先後表示
        /// </summary>
        public Label2 LblSengo
        {
            get
            {
                return this.lblSengo;
            }
        }
        //------------------------------------------------------------
        private Label2 lblFugo;
        /// <summary>
        /// 符号表示
        /// </summary>
        public Label2 LblFugo
        {
            get
            {
                return this.lblFugo;
            }
        }
        //------------------------------------------------------------
        private Button2 btnNaru;
        /// <summary>
        /// 成るボタン
        /// </summary>
        public Button2 BtnNaru
        {
            get
            {
                return this.btnNaru;
            }
        }
        //------------------------------------------------------------
        private Button2 btnMuki;
        /// <summary>
        /// 向きボタン
        /// </summary>
        public Button2 BtnMuki
        {
            get
            {
                return this.btnMuki;
            }
        }
        //------------------------------------------------------------
        private Button2 btnSyokihaichi;
        /// <summary>
        /// 初期配置ボタン
        /// </summary>
        public Button2 BtnSyokihaichi
        {
            get
            {
                return this.btnSyokihaichi;
            }
        }
        //------------------------------------------------------------
        private Button2 btnClear;
        /// <summary>
        /// クリアーボタン
        /// </summary>
        public Button2 BtnClear
        {
            get
            {
                return this.btnClear;
            }
        }
        //------------------------------------------------------------
        private Button2 btnHtml;
        /// <summary>
        /// HTMLボタン
        /// </summary>
        public Button2 BtnHtml
        {
            get
            {
                return this.btnHtml;
            }
        }
        //------------------------------------------------------------
        private Button2 btnPlay;
        /// <summary>
        /// 再生ボタン
        /// </summary>
        public Button2 BtnPlay
        {
            get
            {
                return this.btnPlay;
            }
        }
        //------------------------------------------------------------
        private Button2 btnForward;
        /// <summary>
        /// コマ送りボタン
        /// </summary>
        public Button2 BtnForward
        {
            get
            {
                return this.btnForward;
            }
        }
        //------------------------------------------------------------
        private Button2 btnBackward;
        /// <summary>
        /// 戻る
        /// </summary>
        public Button2 BtnBackward
        {
            get
            {
                return this.btnBackward;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Sente;
        /// <summary>
        /// [▲]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Sente
        {
            get
            {
                return this.btnFugo_Sente;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Gote;
        /// <summary>
        /// [△]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Gote
        {
            get
            {
                return this.btnFugo_Gote;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_1;
        /// <summary>
        /// [１]符号ボタン
        /// </summary>
        public Button2 BtnFugo_1
        {
            get
            {
                return this.btnFugo_1;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_2;
        /// <summary>
        /// [２]符号ボタン
        /// </summary>
        public Button2 BtnFugo_2
        {
            get
            {
                return this.btnFugo_2;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_3;
        /// <summary>
        /// [３]符号ボタン
        /// </summary>
        public Button2 BtnFugo_3
        {
            get
            {
                return this.btnFugo_3;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_4;
        /// <summary>
        /// [４]符号ボタン
        /// </summary>
        public Button2 BtnFugo_4
        {
            get
            {
                return this.btnFugo_4;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_5;
        /// <summary>
        /// [５]符号ボタン
        /// </summary>
        public Button2 BtnFugo_5
        {
            get
            {
                return this.btnFugo_5;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_6;
        /// <summary>
        /// [６]符号ボタン
        /// </summary>
        public Button2 BtnFugo_6
        {
            get
            {
                return this.btnFugo_6;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_7;
        /// <summary>
        /// [７]符号ボタン
        /// </summary>
        public Button2 BtnFugo_7
        {
            get
            {
                return this.btnFugo_7;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_8;
        /// <summary>
        /// [８]符号ボタン
        /// </summary>
        public Button2 BtnFugo_8
        {
            get
            {
                return this.btnFugo_8;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_9;
        /// <summary>
        /// [９]符号ボタン
        /// </summary>
        public Button2 BtnFugo_9
        {
            get
            {
                return this.btnFugo_9;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Dou;
        /// <summary>
        /// [同]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Dou
        {
            get
            {
                return this.btnFugo_Dou;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Fu;
        /// <summary>
        /// [歩]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Fu
        {
            get
            {
                return this.btnFugo_Fu;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Hisya;
        /// <summary>
        /// [飛]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Hisya
        {
            get
            {
                return this.btnFugo_Hisya;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Kaku;
        /// <summary>
        /// [角]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Kaku
        {
            get
            {
                return this.btnFugo_Kaku;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Kyo;
        /// <summary>
        /// [香]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Kyo
        {
            get
            {
                return this.btnFugo_Kyo;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Kei;
        /// <summary>
        /// [桂]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Kei
        {
            get
            {
                return this.btnFugo_Kei;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Gin;
        /// <summary>
        /// [銀]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Gin
        {
            get
            {
                return this.btnFugo_Gin;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Kin;
        /// <summary>
        /// [金]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Kin
        {
            get
            {
                return this.btnFugo_Kin;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Oh;
        /// <summary>
        /// [王]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Oh
        {
            get
            {
                return this.btnFugo_Oh;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Gyoku;
        /// <summary>
        /// [玉]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Gyoku
        {
            get
            {
                return this.btnFugo_Gyoku;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Tokin;
        /// <summary>
        /// [と]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Tokin
        {
            get
            {
                return this.btnFugo_Tokin;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Narikyo;
        /// <summary>
        /// [成香]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Narikyo
        {
            get
            {
                return this.btnFugo_Narikyo;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Narikei;
        /// <summary>
        /// [成桂]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Narikei
        {
            get
            {
                return this.btnFugo_Narikei;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Narigin;
        /// <summary>
        /// [成銀]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Narigin
        {
            get
            {
                return this.btnFugo_Narigin;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Ryu;
        /// <summary>
        /// [竜]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Ryu
        {
            get
            {
                return this.btnFugo_Ryu;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Uma;
        /// <summary>
        /// [馬]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Uma
        {
            get
            {
                return this.btnFugo_Uma;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Yoru;
        /// <summary>
        /// [寄]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Yoru
        {
            get
            {
                return this.btnFugo_Yoru;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Hiku;
        /// <summary>
        /// [引]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Hiku
        {
            get
            {
                return this.btnFugo_Hiku;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Agaru;
        /// <summary>
        /// [上]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Agaru
        {
            get
            {
                return this.btnFugo_Agaru;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Migi;
        /// <summary>
        /// [右]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Migi
        {
            get
            {
                return this.btnFugo_Migi;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Hidari;
        /// <summary>
        /// [左]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Hidari
        {
            get
            {
                return this.btnFugo_Hidari;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Sugu;
        /// <summary>
        /// [直]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Sugu
        {
            get
            {
                return this.btnFugo_Sugu;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Nari;
        /// <summary>
        /// [成]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Nari
        {
            get
            {
                return this.btnFugo_Nari;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Funari;
        /// <summary>
        /// [不成]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Funari
        {
            get
            {
                return this.btnFugo_Funari;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Da;
        /// <summary>
        /// [打]符号ボタン
        /// </summary>
        public Button2 BtnFugo_Da
        {
            get
            {
                return this.btnFugo_Da;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_Zenkesi;
        /// <summary>
        /// [全消]ボタン     ＜入力欄用＞
        /// </summary>
        public Button2 BtnFugo_Zenkesi
        {
            get
            {
                return this.btnFugo_Zenkesi;
            }
        }
        //------------------------------------------------------------
        private Button2 btnFugo_KokokaraSaifu;
        /// <summary>
        /// [ここから採譜]ボタン
        /// </summary>
        public Button2 BtnFugo_KokokaraSaifu
        {
            get
            {
                return this.btnFugo_KokokaraSaifu;
            }
        }
        //------------------------------------------------------------
        #endregion




        public Uc_Main()
        {
            this.taikyoku = new Taikyoku();

            InitializeComponent();
        }

        private void Uc_Main_Load(object sender, EventArgs e)
        {

            //----------
            // 駒
            //----------
            Actions_Kifu.Syokihaichi(this.Taikyoku);
            this.ClearTxtOutput();


            //----------
            // 成るボタン
            //----------
            this.btnNaru = new Button2("成る", 250, 590);

            //----------
            // 向きボタン
            //----------
            this.btnMuki = new Button2("向き", 330, 590);

            //----------
            // 初期配置ボタン
            //----------
            this.btnSyokihaichi = new Button2("初期配置", 450, 590);

            //----------
            // クリアーボタン
            //----------
            this.btnClear = new Button2("クリアー", 450, 630);

            //----------
            // HTMLボタン
            //----------
            this.btnHtml = new Button2("HTML", 570, 630);

            //----------
            // 再生ボタン
            //----------
            this.btnPlay = new Button2("再生", 710, 0);

            //----------
            // コマ送りボタン
            //----------
            this.btnForward = new Button2("コマ送り", 710, 40);

            //----------
            // 戻るボタン
            //----------
            this.btnBackward = new Button2("戻る", 710, 80);

            //----------
            // [▲]～[打]符号ボタン
            //----------
            int ox = 30;
            int oy = 40;
            int w = 23;
            int h = 23;
            float fontSize = 13.0f;
            this.btnFugo_Sente = new Button2("▲", ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Gote = new Button2("△", ox, 1 * h + oy, w, h, fontSize);
            ox += w;

            this.btnFugo_1 = new Button2("１", 0 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_2 = new Button2("２", 1 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_3 = new Button2("３", 2 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_4 = new Button2("４", 0 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_5 = new Button2("５", 1 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_6 = new Button2("６", 2 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_7 = new Button2("７", 0 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_8 = new Button2("８", 1 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_9 = new Button2("９", 2 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_Dou = new Button2("同", 3 * w + ox, 0 * h + oy, w, h, fontSize);
            ox += (4 + 1) * w;

            this.btnFugo_Fu = new Button2("歩", 0 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Hisya = new Button2("飛", 1 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Kaku = new Button2("角", 2 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Kyo = new Button2("香", 3 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Kei = new Button2("桂", 4 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Gin = new Button2("銀", 5 * w + ox, 0 * h + oy, w, h, fontSize);

            this.btnFugo_Kin = new Button2("金", 0 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Oh = new Button2("王", 1 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Gyoku = new Button2("玉", 2 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Tokin = new Button2("と", 3 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Narikyo = new Button2("成香", 4 * w + ox, 1 * h + oy, 2 * w, h, fontSize);

            this.btnFugo_Narikei = new Button2("成桂", 0 * w + ox, 2 * h + oy, 2 * w, h, fontSize);
            this.btnFugo_Narigin = new Button2("成銀", 2 * w + ox, 2 * h + oy, 2 * w, h, fontSize);
            this.btnFugo_Ryu = new Button2("竜", 4 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_Uma = new Button2("馬", 5 * w + ox, 2 * h + oy, w, h, fontSize);
            ox += (6 + 1) * w;

            this.btnFugo_Yoru = new Button2("寄", 0 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Hiku = new Button2("引", 1 * w + ox, 0 * h + oy, w, h, fontSize);
            this.btnFugo_Agaru = new Button2("上", 2 * w + ox, 0 * h + oy, w, h, fontSize);

            this.btnFugo_Migi = new Button2("右", 0 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Hidari = new Button2("左", 1 * w + ox, 1 * h + oy, w, h, fontSize);
            this.btnFugo_Sugu = new Button2("直", 2 * w + ox, 1 * h + oy, w, h, fontSize);

            this.btnFugo_Nari = new Button2("成", 0 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_Funari = new Button2("不成", 1 * w + ox, 2 * h + oy, 2 * w, h, fontSize);
            this.btnFugo_Da = new Button2("打", 3 * w + ox, 2 * h + oy, w, h, fontSize);
            this.btnFugo_Zenkesi = new Button2("全消", 5 * w + ox, 0 * h + oy, w, h, fontSize);

            this.btnFugo_KokokaraSaifu = new Button2("ここから採譜", 9 * w + ox, 0 * h + oy, w, h, fontSize);

            //----------
            // 先後表示
            //----------
            this.lblSengo = new Label2("－－", 350, 145);
            this.Taikyoku.ChangeTurn(Process.INITIALIZED_SUJI, Process.INITIALIZED_DAN, this);//後手にします。
            this.Taikyoku.ChangeTurn(Process.INITIALIZED_SUJI, Process.INITIALIZED_DAN, this);//先手にします。

            //----------
            // 符号表示
            //----------
            this.lblFugo = new Label2("符号", 500, 145);
        }

        public string GetInputText()
        {
            return this.txtInput1.Text;
        }


        private void Uc_Main_Paint(object sender, PaintEventArgs e)
        {
            //----------
            // 将棋盤
            //----------
            this.Taikyoku.Shogiban.Paint(e.Graphics);

            //----------
            // 駒置き
            //----------
            foreach (Komadai k in this.Taikyoku.KomadaiArr)
            {
                k.Paint(e.Graphics);
            }

            //----------
            // 駒
            //----------
            foreach (Button_Koma koma in this.Taikyoku.Kifu.Kyokumen.Items)
            {
                koma.Paint(e.Graphics);
            }

            //----------
            // 成るボタン
            //----------
            this.BtnNaru.Paint(e.Graphics);

            //----------
            // 向きボタン
            //----------
            this.BtnMuki.Paint(e.Graphics);

            //----------
            // 初期配置ボタン
            //----------
            this.BtnSyokihaichi.Paint(e.Graphics);

            //----------
            // クリアーボタン
            //----------
            this.BtnClear.Paint(e.Graphics);

            //----------
            // HTMLボタン
            //----------
            this.BtnHtml.Paint(e.Graphics);

            //----------
            // 再生ボタン
            //----------
            this.BtnPlay.Paint(e.Graphics);

            //----------
            // コマ送りボタン
            //----------
            this.BtnForward.Paint(e.Graphics);

            //----------
            // 戻るボタン
            //----------
            this.BtnBackward.Paint(e.Graphics);

            //----------
            // [▲]～[打]符号ボタン
            //----------
            this.BtnFugo_Sente.Paint(e.Graphics);
            this.BtnFugo_Gote.Paint(e.Graphics);
            this.BtnFugo_1.Paint(e.Graphics);
            this.BtnFugo_2.Paint(e.Graphics);
            this.BtnFugo_3.Paint(e.Graphics);
            this.BtnFugo_4.Paint(e.Graphics);
            this.BtnFugo_5.Paint(e.Graphics);
            this.BtnFugo_6.Paint(e.Graphics);
            this.BtnFugo_7.Paint(e.Graphics);
            this.BtnFugo_8.Paint(e.Graphics);
            this.BtnFugo_9.Paint(e.Graphics);
            this.BtnFugo_Dou.Paint(e.Graphics);
            this.BtnFugo_Fu.Paint(e.Graphics);
            this.BtnFugo_Hisya.Paint(e.Graphics);
            this.BtnFugo_Kaku.Paint(e.Graphics);
            this.BtnFugo_Kyo.Paint(e.Graphics);
            this.BtnFugo_Kei.Paint(e.Graphics);
            this.BtnFugo_Gin.Paint(e.Graphics);
            this.BtnFugo_Kin.Paint(e.Graphics);
            this.BtnFugo_Oh.Paint(e.Graphics);
            this.BtnFugo_Gyoku.Paint(e.Graphics);
            this.BtnFugo_Tokin.Paint(e.Graphics);
            this.BtnFugo_Narikyo.Paint(e.Graphics);
            this.BtnFugo_Narikei.Paint(e.Graphics);
            this.BtnFugo_Narigin.Paint(e.Graphics);
            this.BtnFugo_Ryu.Paint(e.Graphics);
            this.BtnFugo_Uma.Paint(e.Graphics);
            this.BtnFugo_Yoru.Paint(e.Graphics);
            this.BtnFugo_Hiku.Paint(e.Graphics);
            this.BtnFugo_Agaru.Paint(e.Graphics);
            this.BtnFugo_Migi.Paint(e.Graphics);
            this.BtnFugo_Hidari.Paint(e.Graphics);
            this.BtnFugo_Sugu.Paint(e.Graphics);
            this.BtnFugo_Nari.Paint(e.Graphics);
            this.BtnFugo_Funari.Paint(e.Graphics);
            this.BtnFugo_Da.Paint(e.Graphics);
            this.BtnFugo_Zenkesi.Paint(e.Graphics);
            this.BtnFugo_KokokaraSaifu.Paint(e.Graphics);

            //----------
            // 先後表示
            //----------
            this.LblSengo.Paint(e.Graphics);

            //----------
            // 符号表示
            //----------
            this.LblFugo.Paint(e.Graphics);
        }

        private void Uc_Main_MouseMove(object sender, MouseEventArgs e)
        {
            //----------
            // 将棋盤：升目
            //----------
            foreach (Button_Masu cell in this.Taikyoku.Shogiban.MasuList)
            {
                cell.LightByMouse(e.Location.X, e.Location.Y);
                if (cell.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 駒置き：升目
            //----------
            foreach (Komadai komaoki in this.Taikyoku.KomadaiArr)
            {
                foreach (Button_Masu cell in komaoki.MasuList)
                {
                    cell.LightByMouse(e.Location.X, e.Location.Y);
                    if (cell.Light)
                    {
                        this.Refresh();
                    }
                }
            }

            //----------
            // 駒
            //----------
            foreach (Button_Koma koma in this.Taikyoku.Kifu.Kyokumen.Items)
            {
                koma.LightByMouse(e.Location.X, e.Location.Y);
                if (koma.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 成るボタン
            //----------
            {
                this.BtnNaru.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnNaru.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 向きボタン
            //----------
            {
                this.BtnMuki.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnMuki.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 初期配置ボタン
            //----------
            {
                this.BtnSyokihaichi.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnSyokihaichi.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // クリアーボタン
            //----------
            {
                this.BtnClear.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnClear.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // HTMLボタン
            //----------
            {
                this.BtnHtml.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnHtml.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 再生ボタン
            //----------
            {
                this.BtnPlay.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnPlay.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // コマ送りボタン
            //----------
            {
                this.BtnForward.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnForward.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // 戻るボタン
            //----------
            {
                this.BtnBackward.LightByMouse(e.Location.X, e.Location.Y);
                if (this.BtnBackward.Light)
                {
                    this.Refresh();
                }
            }

            //----------
            // [▲]符号ボタン
            //----------
            {
                this.BtnFugo_Sente.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Sente.Light) { this.Refresh(); }
                this.BtnFugo_Gote.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Gote.Light) { this.Refresh(); }
                this.BtnFugo_1.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_1.Light) { this.Refresh(); }
                this.BtnFugo_2.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_2.Light) { this.Refresh(); }
                this.BtnFugo_3.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_3.Light) { this.Refresh(); }
                this.BtnFugo_4.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_4.Light) { this.Refresh(); }
                this.BtnFugo_5.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_5.Light) { this.Refresh(); }
                this.BtnFugo_6.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_6.Light) { this.Refresh(); }
                this.BtnFugo_7.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_7.Light) { this.Refresh(); }
                this.BtnFugo_8.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_8.Light) { this.Refresh(); }
                this.BtnFugo_9.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_9.Light) { this.Refresh(); }
                this.BtnFugo_Dou.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Dou.Light) { this.Refresh(); }
                this.BtnFugo_Fu.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Fu.Light) { this.Refresh(); }
                this.BtnFugo_Hisya.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Hisya.Light) { this.Refresh(); }
                this.BtnFugo_Kaku.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Kaku.Light) { this.Refresh(); }
                this.BtnFugo_Kyo.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Kyo.Light) { this.Refresh(); }
                this.BtnFugo_Kei.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Kei.Light) { this.Refresh(); }
                this.BtnFugo_Gin.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Gin.Light) { this.Refresh(); }
                this.BtnFugo_Kin.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Kin.Light) { this.Refresh(); }
                this.BtnFugo_Oh.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Oh.Light) { this.Refresh(); }
                this.BtnFugo_Gyoku.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Gyoku.Light) { this.Refresh(); }
                this.BtnFugo_Tokin.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Tokin.Light) { this.Refresh(); }
                this.BtnFugo_Narikyo.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Narikyo.Light) { this.Refresh(); }
                this.BtnFugo_Narikei.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Narikei.Light) { this.Refresh(); }
                this.BtnFugo_Narigin.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Narigin.Light) { this.Refresh(); }
                this.BtnFugo_Ryu.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Ryu.Light) { this.Refresh(); }
                this.BtnFugo_Uma.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Uma.Light) { this.Refresh(); }
                this.BtnFugo_Yoru.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Yoru.Light) { this.Refresh(); }
                this.BtnFugo_Hiku.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Hiku.Light) { this.Refresh(); }
                this.BtnFugo_Agaru.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Agaru.Light) { this.Refresh(); }
                this.BtnFugo_Migi.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Migi.Light) { this.Refresh(); }
                this.BtnFugo_Hidari.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Hidari.Light) { this.Refresh(); }
                this.BtnFugo_Sugu.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Sugu.Light) { this.Refresh(); }
                this.BtnFugo_Nari.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Nari.Light) { this.Refresh(); }
                this.BtnFugo_Funari.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Funari.Light) { this.Refresh(); }
                this.BtnFugo_Da.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Da.Light) { this.Refresh(); }
                this.BtnFugo_Zenkesi.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_Zenkesi.Light) { this.Refresh(); }
                this.BtnFugo_KokokaraSaifu.LightByMouse(e.Location.X, e.Location.Y); if (this.BtnFugo_KokokaraSaifu.Light) { this.Refresh(); }
            }
        }

        private void Uc_Main_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //------------------------------------------------------------
                // 左ボタン
                //------------------------------------------------------------


                //----------
                // 既に選択されている駒
                //----------
                Button_Koma selectedBtnKoma = this.Taikyoku.Kifu.Kyokumen.Btn_Selected();


                //----------
                // 将棋盤：升目   ＜移動先など＞
                //----------
                if (null != selectedBtnKoma)
                {
                    // 選択されている駒があるとき
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    foreach (Button_Masu btnMasu in this.Taikyoku.Shogiban.MasuList)
                    {
                        if (btnMasu.HitByMouse(e.Location.X, e.Location.Y))
                        {
                            // どこかの升目をクリックしたとき
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            Actions_Play.Komamove1ByMouseDown( selectedBtnKoma, btnMasu, this.Taikyoku);
                            this.Refresh();
                        }
                    }
                }

                //----------
                // 駒置き：升目
                //----------
                if (null != selectedBtnKoma)
                {
                    // 選択されている駒があるとき
                    //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                    foreach (Komadai komaoki in this.Taikyoku.KomadaiArr)
                    {
                        foreach (Button_Masu btnMasu in komaoki.MasuList)
                        {
                            if (btnMasu.HitByMouse(e.Location.X, e.Location.Y))
                            {
                                // 升目をクリックしたとき
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                Okiba okiba;
                                switch (komaoki.Sengo)
                                {
                                    case Sengo.GOTE:
                                        okiba = Okiba.GOTE_KOMADAI;
                                        break;
                                    default:
                                        okiba = Okiba.SENTE_KOMADAI;
                                        break;
                                }

                                selectedBtnKoma.KomaProperty = new Process(
                                    komaoki.Sengo,// 先手の駒置きに駒を置けば、先手の向きに揃えます。
                                    okiba,
                                    btnMasu.Masu.Suji,
                                    btnMasu.Masu.Dan,
                                    Converter.SyuruiToFunariCase(selectedBtnKoma.KomaProperty.Syurui)//成りは解除。
                                );



                                Actions_Koma.RefreshKomaLocation(selectedBtnKoma, this.Taikyoku);
                                this.Refresh();
                            }
                        }
                    }
                }

                //----------
                // 駒
                //----------
                foreach (Button_Koma koma in this.Taikyoku.Kifu.Kyokumen.Items)
                {
                    koma.SelectByMouse(e.Location.X, e.Location.Y);
                    if (koma.Selected)
                    {
                        // 新たに選択された駒があります
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        if (null == selectedBtnKoma)
                        {
                            // 掴みたい駒の上でマウスダウンしました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                            this.Taikyoku.SetMouseProcessOrNull(new Process(
                                koma.KomaProperty.Sengo,
                                Okiba.NO_USE,
                                koma.KomaProperty.Okiba,
                                Process.TUKAWANAI_SRCSRC_SUJI,
                                Process.TUKAWANAI_SRCSRC_DAN,
                                koma.KomaProperty.Suji,
                                koma.KomaProperty.Dan,
                                KomaSyurui.UNKNOWN,
                                koma.KomaProperty.Syurui,
                                KomaSyurui.TOTTA_KOMA_NASI
                                ));
                        }
                        else
                        {
                            // 掴んだ駒を置く先をマウスダウンしました。
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                            this.Taikyoku.SetMouseProcessOrNull(new Process(
                                koma.KomaProperty.Sengo,
                                selectedBtnKoma.KomaProperty.Okiba,//Okiba.NO_USE,
                                this.Taikyoku.MouseProcessOrNull.SrcOkiba,// koma.KomaProperty.Okiba,
                                Process.TUKAWANAI_SRCSRC_SUJI,
                                Process.TUKAWANAI_SRCSRC_DAN,
                                this.Taikyoku.MouseProcessOrNull.SrcSuji,// koma.KomaProperty.Suji,
                                this.Taikyoku.MouseProcessOrNull.SrcDan,// koma.KomaProperty.Dan,
                                KomaSyurui.UNKNOWN,
                                koma.KomaProperty.Syurui,
                                this.Taikyoku.MouseProcessOrNull.TottaKoma// KomaSyurui.TOTTA_KOMA_NASI
                                ));
                        }


                        this.Taikyoku.Kifu.Kyokumen.ClearAllMoverdFlag();

                        this.Refresh();
                    }
                }

                //----------
                // 成るボタン
                //----------
                {
                    if (this.BtnNaru.HitByMouse(e.Location.X, e.Location.Y))
                    {
                        Button_Koma btnMovedKoma = this.Taikyoku.Kifu.Kyokumen.Btn_MovedKoma();

                        if (null != btnMovedKoma)
                        {
                            // 移動直後の駒があるとき
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            Actions_Play.Nari_KifuLast(btnMovedKoma, this.Taikyoku);
                            this.OutputKifu();
                            this.Refresh();
                        }
                        else if (null != selectedBtnKoma)
                        {
                            // 選択されている駒があるとき
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            Actions_Play.Nari_KifuLast(selectedBtnKoma, this.Taikyoku);
                            this.OutputKifu();
                            this.Refresh();
                        }
                    }
                }

                //----------
                // 向きボタン
                //----------

                if (this.BtnMuki.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Button_Koma movedKoma = this.Taikyoku.Kifu.Kyokumen.Btn_MovedKoma();

                    if (null != movedKoma)
                    {
                        // 移動直後の駒があるとき
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        // TODO:棋譜に反映させたい。

                        switch (movedKoma.KomaProperty.Sengo)
                        {
                            case Sengo.SENTE:
                                movedKoma.KomaProperty = new Process(
                                    Sengo.GOTE,
                                    movedKoma.KomaProperty.Okiba,
                                    movedKoma.KomaProperty.Suji,
                                    movedKoma.KomaProperty.Dan,
                                    movedKoma.KomaProperty.Syurui
                                    );
                                break;

                            case Sengo.GOTE:
                                movedKoma.KomaProperty = new Process(
                                    Sengo.SENTE,
                                    movedKoma.KomaProperty.Okiba,
                                    movedKoma.KomaProperty.Suji,
                                    movedKoma.KomaProperty.Dan,
                                    movedKoma.KomaProperty.Syurui
                                    );
                                break;
                        }

                        this.Refresh();
                    }
                    else if (null != selectedBtnKoma)
                    {
                        // 選択されている駒があるとき
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        switch (selectedBtnKoma.KomaProperty.Sengo)
                        {
                            case Sengo.SENTE:
                                selectedBtnKoma.KomaProperty = new Process(
                                    Sengo.GOTE,
                                    selectedBtnKoma.KomaProperty.Okiba,
                                    selectedBtnKoma.KomaProperty.Suji,
                                    selectedBtnKoma.KomaProperty.Dan,
                                    selectedBtnKoma.KomaProperty.Syurui
                                    );
                                break;

                            case Sengo.GOTE:
                                selectedBtnKoma.KomaProperty = new Process(
                                    Sengo.SENTE,
                                    selectedBtnKoma.KomaProperty.Okiba,
                                    selectedBtnKoma.KomaProperty.Suji,
                                    selectedBtnKoma.KomaProperty.Dan,
                                    selectedBtnKoma.KomaProperty.Syurui
                                    );
                                break;
                        }

                        this.Refresh();
                    }
                }

                //----------
                // 初期配置ボタン
                //----------
                if (this.BtnSyokihaichi.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Kifu.Syokihaichi(this.Taikyoku);
                    this.ClearTxtOutput();
                    this.Refresh();
                }

                //----------
                // クリアーボタン
                //----------
                if (this.BtnClear.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Kifu.Clear(this);
                    this.Refresh();
                }

                //----------
                // HTMLボタン
                //----------
                if (this.BtnHtml.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Kifu.OutputHtml(this);
                    this.Refresh();
                }

                //----------
                // 再生ボタン
                //----------
                if (this.BtnPlay.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Play.Saisei(this);
                }

                //----------
                // コマ送りボタン
                //----------
                if (this.BtnForward.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Play.Komaokuri(this);
                }

                //----------
                // 戻るボタン
                //----------
                if (this.BtnBackward.HitByMouse(e.Location.X, e.Location.Y))
                {
                    Actions_Play.Modoru(this);
                }

                //----------
                // [▲]～[打]符号ボタン
                //----------
                if (this.BtnFugo_Sente.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("▲"); }
                if (this.BtnFugo_Gote.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("△"); }
                if (this.BtnFugo_1.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("１"); }
                if (this.BtnFugo_2.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("２"); }
                if (this.BtnFugo_3.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("３"); }
                if (this.BtnFugo_4.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("４"); }
                if (this.BtnFugo_5.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("５"); }
                if (this.BtnFugo_6.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("６"); }
                if (this.BtnFugo_7.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("７"); }
                if (this.BtnFugo_8.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("８"); }
                if (this.BtnFugo_9.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("９"); }
                if (this.BtnFugo_Dou.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("同"); }
                if (this.BtnFugo_Fu.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("歩"); }
                if (this.BtnFugo_Hisya.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("飛"); }
                if (this.BtnFugo_Kaku.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("角"); }
                if (this.BtnFugo_Kyo.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("香"); }
                if (this.BtnFugo_Kei.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("桂"); }
                if (this.BtnFugo_Gin.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("銀"); }
                if (this.BtnFugo_Kin.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("金"); }
                if (this.BtnFugo_Oh.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("王"); }
                if (this.BtnFugo_Gyoku.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("玉"); }
                if (this.BtnFugo_Tokin.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("と"); }
                if (this.BtnFugo_Narikyo.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("成香"); }
                if (this.BtnFugo_Narikei.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("成桂"); }
                if (this.BtnFugo_Narigin.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("成銀"); }
                if (this.BtnFugo_Ryu.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("竜"); }
                if (this.BtnFugo_Uma.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("馬"); }
                if (this.BtnFugo_Yoru.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("寄"); }
                if (this.BtnFugo_Hiku.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("引"); }
                if (this.BtnFugo_Agaru.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("上"); }
                if (this.BtnFugo_Migi.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("右"); }
                if (this.BtnFugo_Hidari.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("左"); }
                if (this.BtnFugo_Sugu.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("直"); }
                if (this.BtnFugo_Nari.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("成"); }
                if (this.BtnFugo_Funari.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("不成"); }
                if (this.BtnFugo_Da.HitByMouse(e.Location.X, e.Location.Y)) { this.AppendInputText("打"); }
                if (this.BtnFugo_Zenkesi.HitByMouse(e.Location.X, e.Location.Y)) { this.ClearTxtInput(); }
                if (this.BtnFugo_KokokaraSaifu.HitByMouse(e.Location.X, e.Location.Y)) { this.Taikyoku.Kifu.SetStartpos_KokokaraSaifu(this.Taikyoku.Sengo); this.OutputKifu(); }
            }
            else if (e.Button == MouseButtons.Right)
            {
                //------------------------------------------------------------
                // 右ボタン
                //------------------------------------------------------------
                this.Taikyoku.Kifu.Kyokumen.ClearAllSelectedFlag();
            }
        }

        private void Uc_Main_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                //------------------------------------------------------------
                // 左ボタン
                //------------------------------------------------------------


                //----------
                // 将棋盤：升目
                //----------
                foreach (Button_Masu cell in this.Taikyoku.Shogiban.MasuList)
                {
                    if (cell.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // 駒置き：升目
                //----------
                foreach (Komadai komaoki in this.Taikyoku.KomadaiArr)
                {
                    foreach (Button_Masu cell in komaoki.MasuList)
                    {
                        if (cell.DeselectByMouse(e.Location.X, e.Location.Y))
                        {
                            this.Refresh();
                        }
                    }
                }

                //----------
                // 駒
                //----------
                foreach (Button_Koma k in this.Taikyoku.Kifu.Kyokumen.Items)
                {
                    if (k.HitByMouse(e.Location.X, e.Location.Y))
                    {
                        // マウスが重なっていました
                        //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                        if (k.Deselect())
                        {
                            // 動かした駒から、指を放しました
                            //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                            if (k.KomaProperty.DoneMove())
                            {
                                // 駒の移動を、確定しました。
                                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                                Actions_Play.Komamove2ByMouseUp(k,this.Taikyoku, this);

                                this.Refresh();
                            }
                        }
                    }
                }

                //----------
                // 成るボタン
                //----------
                {
                    if (this.BtnNaru.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // 向きボタン
                //----------
                {
                    if (this.BtnMuki.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // 初期配置ボタン
                //----------
                {
                    if (this.BtnSyokihaichi.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // クリアーボタン
                //----------
                {
                    if (this.BtnClear.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // HTMLボタン
                //----------
                {
                    if (this.BtnHtml.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // 再生ボタン
                //----------
                {
                    if (this.BtnPlay.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // コマ送りボタン
                //----------
                {
                    if (this.BtnForward.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // 戻るボタン
                //----------
                {
                    if (this.BtnBackward.DeselectByMouse(e.Location.X, e.Location.Y))
                    {
                        this.Refresh();
                    }
                }

                //----------
                // [▲]～[打]符号ボタン
                //----------
                {
                    if (this.BtnFugo_Sente.DeselectByMouse(e.Location.X, e.Location.Y)){this.Refresh();}
                    if (this.BtnFugo_Gote.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_1.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_2.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_3.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_4.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_5.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_6.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_7.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_8.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_9.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Dou.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Fu.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Hisya.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Kaku.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Kyo.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Kei.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Gin.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Kin.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Oh.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Gyoku.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Tokin.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Narikyo.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Narikei.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Narigin.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Ryu.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Uma.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Yoru.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Hiku.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Agaru.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Migi.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Hidari.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Sugu.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Nari.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Funari.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Da.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_Zenkesi.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                    if (this.BtnFugo_KokokaraSaifu.DeselectByMouse(e.Location.X, e.Location.Y)) { this.Refresh(); }
                }
            }
            else if (e.Button == MouseButtons.Right)
            {
                //------------------------------------------------------------
                // 右ボタン
                //------------------------------------------------------------
            }

        }

        public void ClearTxtInput()
        {
            this.txtInput1.Text = "";
        }

        public void ClearTxtOutput()
        {
            this.txtOutput1.Text = "";
            this.txtOutput2.Text = "";
        }

        public void SetTxtOutput(string value)
        {
            this.txtOutput1.Text = value;
        }

        public string GetTxtOutput()
        {
            return this.txtOutput1.Text;
        }

        private void txtStandard_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == System.Windows.Forms.Keys.A & e.Control == true)
            {
                ((TextBox)sender).SelectAll();
            } 
        }

        private void txtOutput2_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == System.Windows.Forms.Keys.A & e.Control == true)
            {
                ((TextBox)sender).SelectAll();
            } 
        }

        private void txtInput1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == System.Windows.Forms.Keys.A & e.Control == true)
            {
                ((TextBox)sender).SelectAll();
            } 
        }
    }
}
